/*
 * unity-webapps-binding.h
 * Copyright (C) Canonical LTD 2012
 * 
 * Author: Alexandre Abreu <alexandre.abreu@canonical.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#if ! defined (UNITY_WEBAPPS_BINDING_UTILS_H)
#define UNITY_WEBAPPS_BINDING_UTILS_H


#include "npapi-headers/headers/npapi.h"
#include "npapi-headers/headers/nptypes.h"


bool
is_null_or_void (NPVariant variant);

gchar *
create_safe_string_for (const NPVariant * const pVariant);

// boolean semantics "acceptance" criteria are pretty 'broad'
gboolean
is_boolean_convertible_value (NPVariant variant);

gboolean
extract_boolean_value_from (NPVariant variant);


#endif // UNITY_WEBAPPS_BINDING_UTILS_H
