/*
 * unity-webapps-repo-userscript-wrapper.h
 * Copyright (C) Canonical LTD 2012
 * 
 * Author: Alexandre Abreu <alexandre.abreu@canonical.com>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#if ! defined (UNIT_WEBAPPS_REPO_USERSCRIPTWRAPPER_H)
#define UNIT_WEBAPPS_REPO_USERSCRIPTWRAPPER_H

#include <glib.h>

#include "npapi-headers/headers/npapi.h"
#include "npapi-headers/headers/npfunctions.h"

#include "unity-npapi-common.h"


typedef struct UnityWebappsRepoUserScriptWrapper_t
{
  NPObject object;
  
  NPP instance;
  
  char * name;
  
  // named methods, string -> UnityWebAppsNpapiMethodPtr
  GHashTable * methods;
  
  // string -> UnityWebAppsNpapiPropertyDescr *
  GHashTable * properties;
  
  // if array access is supported, right now only GET is allowed
  UnityWebAppsNpapiIndexedGetPtr array_access;
  
  // custom allocator / deallocator
  //TODO 
  
  void * reserved;

} UnityWebappsRepoUserScriptWrapper;


NPObject *
unity_webapps_npapi_create_integrationscript_repo_wrapper_for (NPP instance);


#endif // UNIT_WEBAPPS_REPO_USERSCRIPTWRAPPER_H

