var UnityBindingFactory = function (pluginInstance, service, logger) {
	
	var _context = null;
	var _instance = pluginInstance;

	function Unity () {
		this.service = service;
		this.logger = logger;
	};

    function _initializeWithName (name, service, iconUrl, oninit) {
		var appRaise = function (context, userData) { console.log ("appRaise"); };
		var appClose = function (context, userData) { console.log ("appClose"); };
		var previewRequested = function (context, user_data) { console.log ("previewRequested"); };

		_context = _instance.context_new_sync (service, name, document.domain, "null");

//		_instance.context_add_icon (unityContext, UnityFaviconUtils.getFaviconForDocument (aWindow.document), 16);
		_instance.context_on_raise_callback (_context, appRaise, null);
		_instance.context_on_close_callback (_context, appClose, null);
		_instance.context_set_preview_requested_callback (_context, previewRequested, null);
		
		if (oninit != null) {
			try {
				oninit();
			} catch (e) {
				console.log ("Unity Extension, error calling onInit callback: " + e.toString());
			}
		}

        _instance.context_set_view_is_active (_context, 0);

//		unityContext.document = aWindow.document;
//		unityContext.parent = aWindow.parent;
		
		_instance.context_set_view_location (_context, document.location.toString());
    };

	Unity.prototype = {
		init: function unityInit (props) {
			
			var name = props.name || "Undefined name";
			var onInit = props.onInit || function () { console.log ("Default onInit called for '" + name + "'") };
			
			_initializeWithName (name, this.service, '', onInit);

			console.log ('init: ' + _context);
    	},
		MusicPlayer: {
            
            init: function(name) {
            	console.log('Music player: ' + this)
				if (_context == null) {return};

				_instance.music_player_init (_context, name);
            },
            
            onPlayPause: function (callback) {
				if (_context == null) {return};

				_instance.music_player_on_play_pause_callback (_context, callback, null);
            },

            onPrevious: function(callback) {
				if (_context == null) {return};

				_instance.music_player_on_previous_callback (_context, callback, null);
            },

            onNext: function(callback) {
				if (_context == null) {return};

				_instance.music_player_on_next_callback (_context, callback, null);
            },
    
            setTrack: function(track) {
				if (unityContext == null) {return};
		
				var artist = String(track.artist);
				var album = String(track.album);
		
				if (track.title == null) {
				    throw "track.title is null";
				}
				
				var title = String(track.title);
				var artLocation = String(track.artLocation);

				_instance.music_player_set_track_metadata (_context, artist, album, title, artLocation);
            },

            PlaybackState: {PLAYING: 0, PAUSED:1}
		},

		Notification: {
            showNotification: function(summary, body, iconLocation) {
            	summary = summary || "unknown";
            	body = body || "unknown";
            	iconLocation = iconLocation || "unknown";
            	
				if (_context == null) {return};
				
				return _instance.notification_show_notification (_context,
									summary,
									body,
									iconLocation);
            }
		},
	};
    
    return function () {
	    return new Unity ();
	}
};

