(function () {
	var performContentScriptInitialization = function () {
		window.getTabId = function (callback) {
			chrome.extension.sendRequest ({method: "get_this_tab"}, callback);
		};
		
		window.killTabWithId = function (tabId) {
			chrome.extension.sendRequest ({method: "kill_this_tab", tabId: tabId});
		};
		
		window.raiseTabWithId = function (tabId) {
			chrome.extension.sendRequest ({method: "raise_this_tab", tabId: tabId});
		};
		
		(function () {
			var logger = function (msg) { console.log ("Content script: " + msg); };

			// does the unity script injection + user script if necessary
			logger ('url: ' + document.URL);

			var insertScript = function (src) {
			    var script = document.createElement ('script');
			    
			    script.type = 'text/javascript';
			    script.src = chrome.extension.getURL (src);

			    document.getElementsByTagName("head")[0].appendChild (script);
			}

			var addPluginNode = function () {
				var element = document.createElement ('embed');
				element.type = 'application/x-unity-webapps-npapi';
				element.id = 'unityChromiumExtensionId';
				element.height = 0;
				element.width = 0;
				document.getElementsByTagName("body")[0].appendChild (element);
			};

			var getUserScriptContent = function (url) {
			    var content = null;
			    var xhr = new XMLHttpRequest();

			    xhr.onreadystatechange = function() {
			        if (xhr.readyState == 4) {
			            content = xhr.responseText;
			        }
			    };

			    // mmh blocking
			    xhr.open("GET", url, false);

			    try {
			        xhr.send();
			    } catch(e) {
			        logger ('Could not load user script content from: ' + url);
			    }

			    return content;
			}


			/**
			 * We send our URL and potentially receive something (scripts to insert)
			 * 
			 */
			chrome.extension.sendRequest ({method: "get_unity_script", url: document.URL}, function (response) {
				logger (response.userscript);
				
				if (null !== response.userscript) {

					/**
					 * Setup the environment
					 *
					 */

					// is added in the current document/environment (content script page)
					addPluginNode ();

					// inject Unity binding, evil eval because otherwise the script will be injected in the
					//	current website w/ obviously all accesses to chrome.extension disabled and therefore
					//	forces communication thru events w/ the content script
					eval.call (window, getUserScriptContent (chrome.extension.getURL ("unity-api.js")));
					eval.call (window, getUserScriptContent (chrome.extension.getURL ("unity-webapps-binding.js")));
					
					// OMG!! this is bad, wee need a global / structure scheme, where we inject things like
					// 	unsafeWindow, etc. into scripts
					eval.call (window, 'unsafeWindow = window;');

					eval.call (window, getUserScriptContent (chrome.extension.getURL ("integration-scripts/utils.js")));
					
					eval.call (window, getUserScriptContent (chrome.extension.getURL ("integration-scripts/google-common.js")));

					console.log ('Unity has been injected: ' + Unity);

					// evil eval again see above ...
					eval.call (window, getUserScriptContent (chrome.extension.getURL (response.userscript)));
				}
			});

		})();
	};

	if (top === self) {
		performContentScriptInitialization ();
	}

}) ();

