// ==UserScript==
// @name          gplus-unity-integration
// @include       https://plus.google.com/*
// @version       0.9
// @author        WebApps Team
// @require       utils.js
// @require       google-common.js
// ==/UserScript==

function isCorrectPage() {
    var i, ids = ['contentPane'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function messagingIndicatorSetup() {
    var container = document.getElementById('contentPane');

    function checkMessangesCount() {
        var i, unreadItems = document.evaluate('div/div[3]/div/div[@class="Wbhcze Te ch"]', container, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

        var unread = '0';
        if (unreadItems) {
            unread = String(unreadItems.snapshotLength);
        }

        Unity.MessagingIndicator.showIndicator(_("Unread"), { count: unread });

        var node, icon, author, body;
        for (i = 0; i < unreadItems.snapshotLength; i++) {
            node = unreadItems.snapshotItem(i);
            icon = document.evaluate('div/div/a/img', node,
                                     null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue.src;
            author = document.evaluate('div/div/div/span/a', node,
                                       null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue.textContent;
            body = document.evaluate('div/div[2]/div/div/div', node,
                                     null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue.textContent;

            console.log(author);

            if (body && !localStorage.getItem(body)) {
                localStorage.setItem(body, true);
                Unity.Notification.showNotification(author, body, icon);
            }
        }

    }

    checkMessangesCount();
    container.addEventListener('DOMSubtreeModified', checkMessangesCount, false);

    doMainMenuIntegration(document);
}

if (isCorrectPage()) {
    Unity.toDataURL('http://ssl.gstatic.com/s2/oz/images/google-logo-plus-0fbe8f0119f4a902429a5991af5db563.png', function (aResult, uri) {
        Unity.init({ name: "Google+",
                     iconUrl: uri,
                     onInit: messagingIndicatorSetup });
    });
}
