// ==UserScript==
// @name          greader-unity-integration
// @include       https://www.google.com/reader/view/*
// @include       http://www.google.com/reader/view/*
// @version       0.9
// @author        WebApps Team
// @require       utils.js
// @require       google-common.js
// ==/UserScript==

function doHUDIntegration() {
    function expandNode(node, path) {
        var i, childs = node.childNodes;
        for (i = 0; i < childs.length; i++) {
            var link = childs[i].childNodes[1];
            var title = link.textContent.match(/^[^(]+/)[0];

            console.log(path + '/' + title);
            Unity.addAction(path + '/' + title, makeRedirector(link.href));
            if (childs[i].childNodes.length > 2) {
                expandNode(childs[i].childNodes[2], path + '/' + title);
            }
        }
    }
    var root = document.evaluate('//div[@id="sub-tree-container"]/ul/li/ul',
                                 document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue;
    expandNode(root, '/Subscriptions');
}

function isCorrectPage() {
    var i, ids = ['reading-list-unread-count'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function messagingIndicatorSetup() {
    var countElement = document.getElementById('reading-list-unread-count');
    function checkMessangesCount() {
        var count = countElement.textContent;

        count = count.substr(1, count.length - 2);
        Unity.MessagingIndicator.showIndicator(_("unread"), { count: count });
    }

    countElement.addEventListener('DOMSubtreeModified', messagingIndicatorSetup, false);

    checkMessangesCount();
    doMainMenuIntegration(document);
    doHUDIntegration();
}

if (isCorrectPage()) {
    Unity.toDataURL('http://www.google.com/reader/ui/537640976-reader-logo-en.gif', function (aResult, uri) {
        Unity.init({ name: "Google Reader",
                     iconUrl: uri,
                     onInit: messagingIndicatorSetup });
    });
}

