// ==UserScript==
// @name          grooveshark-unity-integration
// @include       http://grooveshark.com/#!/*
// @version       0.9
// @author        WebApps Team
// ==/UserScript==

function isCorrectPage() {
    var i, ids = ['player_play_pause', 'player_next'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function getTrackInfo() {
    var artist = null;
    var title = document.title;
    var artLocation = null;
    var album = null;
    try {
        artist = document.evaluate('//*[@id="playerDetails_current_song"]/a[@class="artist"]', document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue.title;
        title = document.getElementsByClassName('currentSongLink song')[0].title;
        album = document.evaluate('//*[@id="playerDetails_current_song"]/a[@class="album"]', document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue.title;
        artLocation = document.evaluate('//*[@class="queue-item queue-item-active"]/div/div/div/img', document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue.src;
    } catch (x) {}

    if (!artLocation) {
        return null;
    }

    return {
        title: title,
        album: album,
        artist: artist,
        artLocation: artLocation
    };
}

function musicPlayerSetup() {
    Unity.MusicPlayer.init("Grooveshark");

    setInterval(function retry() {
        var trackInfo = getTrackInfo();

        if (!trackInfo) {
            return;
        }

        var paused = document.getElementById('player_play_pause').className.match(/pause$/);
        Unity.MusicPlayer.playbackState = !paused;

        Unity.MusicPlayer.setTrack(trackInfo);
    }, 1000);

    Unity.MusicPlayer.onPlayPause(function () {
        document.getElementById('player_play_pause').click();
    });

    Unity.MusicPlayer.onNext(function () {
        document.getElementById('player_next').click();
    });

    Unity.MusicPlayer.onPrevious(function () {
        document.getElementById('player_previous').click();
    });
}

if (isCorrectPage()) {
    Unity.toDataURL('http://upload.wikimedia.org/wikipedia/en/thumb/6/67/Grooveshark_logo.png/200px-Grooveshark_logo.png', function (aResult, uri) {
        Unity.init({ name: "Grooveshark",
                     iconUrl: uri,
                     onInit: musicPlayerSetup });
    });
}
