// ==UserScript==
// @name          hulu-unity-integration
// @include       http://www.hulu.com/watch/*
// @version       0.9
// @author        WebApps Team
// @require       utils.js
// ==/UserScript==

evalInPageContext(function () {
     // player don't have playVideo/pauseVideo/getCurrentTime methods
     // in greasemonkey context.

    function isCorrectPage() {
        var i, ids = [];

        for (i = 0; i < ids.length; i++) {
            if (!document.getElementById(ids[i])) {
                return false;
            }
        }

        return true;
    }

    function extractText(element) {
        var i, result = '';

        for (i = 0; i < element.childElementCount; i++) {
            var child = element.children[i];
            if (child.textContent) {
                result += child.textContent;
            } else {
                result += extractText(child);
            }
        }
        return result;
    }

    function getTrackInfo() {
        var title = extractText(document.getElementById('show-title-container'));
        var album = extractText(document.getElementsByClassName('show-name cufonable')[0]);
        return {
            title: title,
            album: album,
            artist: null,
            artLocation: 'http://static.huluim.com/images/logo.jpg'
        };
    }

    function getPlayerState(callback) {
        var player = document.getElementById('player');
        var time = player.getCurrentTime();
        setTimeout(function () {
            callback(player.getCurrentTime() === time);
        }, 100);
    }

    function playOrPause() {
        getPlayerState(function (isPaused) {
            var player = document.getElementById('player');
            if (isPaused) {
                player.resumeVideo();
            } else {
                player.pauseVideo();
            }
        });
    }

    function musicPlayerSetup() {
        Unity.MusicPlayer.init("Hulu");
        Unity.MusicPlayer.canGoPrevious = false;

        Unity.MusicPlayer.onPlayPause(function () {
            playOrPause();
        });

        Unity.MusicPlayer.onNext(function () {
            var player = document.getElementById('player');
            player.nextVideo();
        });

        setInterval(function () {
            Unity.MusicPlayer.setTrack(getTrackInfo());

            getPlayerState(function (isPaused) {
                if (!isPaused) {
                    Unity.MusicPlayer.playbackState = Unity.MusicPlayer.PlaybackState.PLAYING;
                } else {
                    Unity.MusicPlayer.playbackState = Unity.MusicPlayer.PlaybackState.PAUSED;
                }
            });
        }, 1000);

        Unity.MusicPlayer.setTrack(getTrackInfo());
    }

    if (isCorrectPage()) {
        Unity.init({ name: "Hulu",
                     iconUrl: 'http://static.huluim.com/images/logo.jpg',
                     onInit: musicPlayerSetup });
    }
});
