// ==UserScript==
// @name          linkedin-unity-integration
// @include       http://www.linkedin.com/*
// @include       http://www.linkedin.com
// @version       0.9
// @author        WebApps Team
// @require       utils.js
// ==/UserScript==

function isCorrectPage() {
    var i, ids = ['header', 'nav-primary-news'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function doMatrixIntegration() {
    function integrateSubMenu(parent) {
        var i, snapshot = document.evaluate('ul/li/a',
                                            parent, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
        for (i = 0; i < snapshot.snapshotLength; i++) {
            var node = snapshot.snapshotItem(i);
            var text = node.textContent;
            var link = node.href;
            console.log(text);
            Unity.addAction('/' + text, makeRedirector(link));
        }
    }
    var i, snapshot = document.evaluate('//div[@id="header"]/div[2]/div/ul/li',
                                        document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);

    for (i = 0; i < snapshot.snapshotLength; i++) {
        var node = snapshot.snapshotItem(i);
        var text = node.getElementsByTagName('a')[0].getElementsByTagName('span')[0].textContent;
        var link = node.getElementsByTagName('a')[0].href;

        console.log(text);
        Unity.addAction('/' + text, makeRedirector(link));
        integrateSubMenu(node);
    }
}

function messagingIndicatorSetup() {
    setInterval(function () {
        var count = document.getElementById('nav-primary-inbox-item-total');

        if (count) {
            count = count.textContent.match(/\d+/)[0];
            Unity.MessagingIndicator.showIndicator(_("Inbox"), { count: count });
        }
    }, 4000);

    function composeNewMessage() {
        document.evaluate('//div[@id="inbox-overlay-messages-header"]/div[2]/a',
                          document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue.click();
    }
    Unity.Launcher.addAction(_("Compose New Message"),
			     composeNewMessage);

    doMatrixIntegration();
}

if (isCorrectPage()) {
    Unity.toDataURL('http://upload.wikimedia.org/wikipedia/commons/thumb/0/01/LinkedIn_Logo.svg/200px-LinkedIn_Logo.svg.png', function (aResult, uri) {
        Unity.init({ name: 'LinkedIn',
                     iconUrl: uri,
                     onInit: messagingIndicatorSetup });
    });

}
