// ==UserScript==
// @name          live-com-unity-integration
// @include       http://*.live.com/*
// @include       https://*.live.com/*
// @version       0.9
// @author        WebApps Team
// ==/UserScript==

function isCorrectPage() {
    var i, ids = ['c_murc', 'c_mocc'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function messagingIndicatorSetup() {
    var inboxCountElement = document.getElementById('c_murc');
    var messengerCountElement = document.getElementById('c_mocc');
    function checkMessangesCount() {
        var count = inboxCountElement.textContent.match(/\d+/)[0];

        Unity.MessagingIndicator.showIndicator("Inbox", { count: count });

        count = '0';
        if (messengerCountElement.textContent.length) {
            count = messengerCountElement.textContent.match(/\d+/)[0];
        }

        Unity.MessagingIndicator.showIndicator("Messenger", { count: count });
    }

    inboxCountElement.addEventListener('DOMSubtreeModified', checkMessangesCount, false);
    messengerCountElement.addEventListener('DOMSubtreeModified', checkMessangesCount, false);

    checkMessangesCount();
}

if (isCorrectPage()) {
    Unity.toDataURL('https://secure.wlxrs.com/$live.controls.images/h/s7.png', function (aResult, uri) {
        Unity.init({ name: "live.com",
                     iconUrl: uri,
                     onInit: messagingIndicatorSetup });
    }, 0, 6, 17, 18);
}
