// ==UserScript==
// @name          twitter-unity-integration
// @include       https://twitter.com/*
// @version       0.9
// @author        WebApps Team
// ==/UserScript==

function isCorrectPage() {
    var i, ids = ['doc', 'banners', 'page-outer'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function messagingIndicatorSetup() {
    var container = document.getElementById('page-container');
    function checkMessangesCount() {
        if (container) {
            var streamContainer = document.getElementsByClassName('stream-container')[0];
            if (streamContainer) {
                container.removeEventListener('DOMSubtreeModified', checkMessangesCount, false);
                streamContainer.addEventListener('DOMSubtreeModified', checkMessangesCount, false);
                container = null;
            }
        }

        var title = "tweets";

        var label = document.getElementsByClassName('search-query')[0];
        if (label) {
            title = label.textContent;
        }

        var count = document.getElementById('new-tweets-bar');

        if (!count) {
            count = '0';
        } else {
            count = count.textContent.match(/^\d+/)[0];
        }

        Unity.MessagingIndicator.showIndicator(title, { count: count });
    }

    container.addEventListener('DOMSubtreeModified', checkMessangesCount, false);

    checkMessangesCount();
}

if (isCorrectPage()) {
    Unity.init({ name: "Twitter",
                 iconUrl: 'http://twimg0-a.akamaihd.net/a/1325363157/phoenix/img/twitter_logo_right.png',
                 onInit: messagingIndicatorSetup });
}

