// ==UserScript==
// @name          vk-com-unity-integration
// @include       http://vk.com/*
// @version       0.9
// @author        WebApps Team
// @require       utils.js
// ==/UserScript==

function isCorrectPage() {
    var i, ids = ['top_links', 'logout_frame'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function playerSetup() {
    var audioPlayer = window.audioPlayer;
    if (!audioPlayer) {
        return;
    }
    if (audioPlayer.player) {
        if (!audioPlayer.player.paused()) {
            Unity.MusicPlayer.playbackState = Unity.MusicPlayer.PlaybackState.PLAYING;
        } else {
            Unity.MusicPlayer.playbackState = Unity.MusicPlayer.PlaybackState.PAUSED;
        }
    }

    Unity.MusicPlayer.onPlayPause(function () {
        if (audioPlayer.player.paused()) {
            audioPlayer.playTrack();
        } else {
            audioPlayer.pauseTrack();
        }
    });

    Unity.MusicPlayer.setTrack({
        title: audioPlayer.lastSong[6],
        album: null,
        artist: audioPlayer.lastSong[5],
        artLocation: null
    });

    Unity.MusicPlayer.onNext(function () {
        audioPlayer.nextTrack();
    });

    Unity.MusicPlayer.onPrevious(function () {
        audioPlayer.prevTrack();
    });
}

function messagingIndicatorSetup() {
    var countElement = document.evaluate('//li[@id="l_msg"]/a/span[2]', document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue;
    function checkMessangesCount() {
        var count = countElement.textContent;
        if (!count.length) {
            count = '0';
        }

        Unity.MessagingIndicator.showIndicator(_("Inbox"), { count: count });
    }

    countElement.addEventListener('DOMSubtreeModified', checkMessangesCount, false);

    checkMessangesCount();

    evalInPageContext('function () {setInterval(' + playerSetup + ', 1000);}');
}

if (isCorrectPage()) {
    Unity.toDataURL('http://upload.wikimedia.org/wikipedia/commons/thumb/3/36/Vkontakte.png/800px-Vkontakte.png', function (aResult, uri) {
        Unity.init({ name: _("vk.com"),
                     iconUrl: uri,
                     onInit: messagingIndicatorSetup });
    });
}

