// ==UserScript==
// @name          yandex-music-unity-integration
// @include       http://music.yandex.ru/*
// @include       https://music.yandex.ru/*
// @version       0.9
// @author        WebApps Team
// @require       utils.js
// ==/UserScript==

function isCorrectPage() {
    if (!document.getElementsByClassName('b-head-logo__legal')[0]) {
        return false;
    }

    return true;
}

function getTrackInfo() {
    var artist = document.getElementsByClassName('b-link js-player-artist')[0].textContent;
    var artLocation = document.getElementsByClassName('b-jambox__cover js-player-cover')[0].src;
    var title = document.getElementsByClassName('b-link js-player-title')[0].textContent;

    var trackInfo = {
        title: '11',
        album: null,
        artist: '22',
        artLocation: artLocation
    };
    return trackInfo;
}

function musicPlayerSetup() {
    Unity.MusicPlayer.init(_("Yandex Music"));

    setInterval(function () {
        Unity.MusicPlayer.setTrack(getTrackInfo());
    }, 3000);

    Unity.MusicPlayer.onPlayPause(function () {
        document.getElementsByClassName('b-jambox__play__i')[0].click();
    });

    Unity.MusicPlayer.onNext(function () {
        document.getElementsByClassName('b-jambox__button b-jambox__button_type_next js-player-next')[0].click();
    });

    Unity.MusicPlayer.onPrevious(function () {
        document.getElementsByClassName('b-jambox__button b-jambox__button_type_prev js-player-prev')[0].click();
    });
}

if (isCorrectPage()) {
    Unity.toDataURL('http://upload.wikimedia.org/wikipedia/ru/e/e4/YandexMusicLogo.PNG', function (aResult, uri) {
        Unity.init({ name: _("Yandex Music"),
                     iconUrl: uri,
                     onInit: musicPlayerSetup });
    });
}
