// ==UserScript==
// @name          yandex-unity-integration
// @include       http://news.yandex.ru/*
// @include       https://news.yandex.ru/*
// @version       0.9
// @author        WebApps Team
// @require       utils.js
// ==/UserScript==

function isCorrectPage() {
    if (!document.getElementsByClassName('b-head-logo')[0]) {
        return false;
    }

    if (parent.document !== document) {
        return false;
    }
    return true;
}

function markAsRead(items) {
    var i;
    for (i = 0; i < items.length; i++) {
        localStorage.setItem(items[i], true);
    }
}

function getHeaders(doc) {
    var res = [], i;

    var snapshot = doc.evaluate('//tr/td/div/dl/dt[@class="head"]/a',
                                doc, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    console.log('total:' + snapshot.snapshotLength);
    for (i = 0; i < snapshot.snapshotLength; i++) {
        var node = snapshot.snapshotItem(i);
        if (node.textContent.length && !localStorage.getItem(node.textContent)) {
            res.push(node.textContent);
        }
    }
    console.log('new:' + res.length);
    return res;
}

function showNotifications(items) {
    var i;
    for (i = 0; i < items.length; i++) {
        Unity.Notification.showNotification(_("Yandex News"), items[i], null);
    }
    markAsRead(items);
}

function messagingIndicatorSetup() {
    var iframe = document.createElement('iframe');
    iframe.width = 0;
    iframe.height = 0;
    iframe.src = "http://news.yandex.ru/?sdasda";
    document.body.appendChild(iframe);
    markAsRead(getHeaders(document));

    function retry() {
        iframe.src = "http://news.yandex.ru/?sdasda";
    }
    iframe.onload = function () {
        showNotifications(getHeaders(iframe.contentWindow.document));
        setTimeout(retry, 5000);
    };
    retry();
}

if (isCorrectPage()) {
    Unity.toDataURL('http://yandex.st/lego/2.2.9/common/block/b-head-logo/b-head-logo.png', function (aResult, uri) {
        Unity.init({ name: _("Yandex News"),
                     iconUrl: uri,
		     onInit: messagingIndicatorSetup });
    });
}
