// ==UserScript==
// @include       http://youtube.com/*
// @include       http://*.youtube.com/*
// @include       https://youtube.com/*
// @include       https://*.youtube.com/*
// @version       0.9
// @author        WebApps Team
// ==/UserScript==

/* Testing URL:
 * http://www.youtube.com/watch?v=v1TsCud9QhU&feature=autoplay&list=PLDA83A73D581CEFCC&lf=plpp_play_all&playnext=120
 */

function isCorrectPage() {
    var i, ids = ['page', 'footer-container'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function evalInPageContext(func) {
    var script = document.createElement('script');
    script.appendChild(document.createTextNode('(' + func + ')();'));
    (document.body || document.head || document.documentElement).appendChild(script);
}

function musicPlayerSetup() {
    var titleLabel = document.getElementById("eow-title");
    var artLocation = "http://bsmeyersauthor.files.wordpress.com/2011/06/youtubetrans.png";
    var imgContainer = document.getElementsByClassName('playlist-bar-item yt-uix-slider-slide-unit playlist-bar-item-playing');

    try {
        artLocation = imgContainer.item(0).firstChild.firstChild.firstChild.firstChild.src;
    } catch (x) {}

    var trackInfo = {
        title: titleLabel.title,
        album: null,
        artist: null,
        artLocation: artLocation
    };

    Unity.MusicPlayer.init("YouTube");

    Unity.MusicPlayer.setTrack(trackInfo);

    function changeState(dryRun) {
        // player don't have playVideo/pauseVideo methods
        // in greasemonkey context.
        var isPlaying;
        var player = document.getElementById('movie_player');
        if (player) {
            isPlaying = player.getPlayerState() === 1;
            if (!dryRun) {
                if (isPlaying) {
                    player.pauseVideo();
                } else {
                    player.playVideo();
                }
                isPlaying = !isPlaying;
            }
        } else { //html5 player
            var button = document.evaluate('//div[@id="movie_player-html5"]/div[3]/div[2]/button', document, null, XPathResult.ANY_UNORDERED_NODE_TYPE, null).singleNodeValue;
            isPlaying = !String(button.className).match(/html5-pause-button/);
            if (!dryRun) {
                button.click();
                isPlaying = !isPlaying;
            }
        }
        if (isPlaying) {
            Unity.MusicPlayer.playbackState = Unity.MusicPlayer.PlaybackState.PLAYING;
        } else {
            Unity.MusicPlayer.playbackState = Unity.MusicPlayer.PlaybackState.PAUSED;
        }
    }
    Unity.MusicPlayer.onPlayPause(function () {
        evalInPageContext(changeState);
    });

    Unity.MusicPlayer.onNext(function () {
        document.getElementById("playlist-bar-next-button").click();
    });

    Unity.MusicPlayer.onPrevious(function () {
        document.getElementById("playlist-bar-prev-button").click();
    });

    evalInPageContext('function() {setInterval(function() {(' + String(changeState) + ')(true)}, 1000);}');
}

if (isCorrectPage()) {
    Unity.toDataURL('http://s.ytimg.com/yt/favicon-refresh-vfldLzJxy.ico', function (aResult, uri) {
        Unity.init({ name: "YouTube",
                     iconUrl: uri,
                     onInit: musicPlayerSetup });
    });
}
