function isCorrectPage() {
    var i, ids = ['page', 'footer-container'];

    for (i = 0; i < ids.length; i++) {
        if (!document.getElementById(ids[i])) {
            return false;
        }
    }

    return true;
}

function evalInPageContext(func) {
    var script = document.createElement('script');
    script.appendChild(document.createTextNode('(' + func + ')();'));
    (document.body || document.head || document.documentElement).appendChild(script);
}

function musicPlayerSetup() {
    var titleLabel = document.getElementById ("eow-title");
    var artLocation = "http://bsmeyersauthor.files.wordpress.com/2011/06/youtubetrans.png";
    var imgContainer = document.getElementsByClassName('playlist-bar-item yt-uix-slider-slide-unit playlist-bar-item-playing');

    try {
        artLocation = imgContainer.item(0).firstChild.firstChild.firstChild.firstChild.src;
    } catch (x) {}

    var trackInfo = {
        title: titleLabel.title,
        album: null,
        artist: null,
        artLocation: artLocation
    };

    Unity.MusicPlayer.init ("YouTube");

    console.log ('From youtube user script: ' + trackInfo.title);

    Unity.MusicPlayer.setTrack (trackInfo);

    function playOrPause() {
        // player don't have playVideo/pauseVideo methods
        // in greasemonkey context.
        var player = document.getElementById('movie_player');
        var isPlaying = player.getPlayerState() === 1;
        if (isPlaying) {
            player.pauseVideo();
        } else {
            player.playVideo();
        }
    }

    Unity.MusicPlayer.onPlayPause (function () {
        console.log ('Unity.MusicPlayer.onPlayPause callback');
        evalInPageContext (playOrPause);
    });

    Unity.MusicPlayer.onNext (function () {
        console.log ('Unity.MusicPlayer.onNext callback');
        document.getElementById ("playlist-bar-next-button").click();
    });

    Unity.MusicPlayer.onPrevious (function () {
        console.log ('Unity.MusicPlayer.onPrevious callback');
        document.getElementById ("playlist-bar-prev-button").click();
    });
}

if (isCorrectPage()) {
//    Unity.toDataURL('http://s.ytimg.com/yt/favicon-refresh-vfldLzJxy.ico', function (aResult, uri) {
        Unity.init({ name: "YouTube",
                     iconUrl: '',
                     onInit: musicPlayerSetup });
  //  });
}
