// copy from lp:unity-firefox-extension/unity-firefox-extension/content/unity-api.js
// It should be sync with it.

var EXPORTED_SYMBOLS = [ "makeAPI" ];

function makeAPI(init, toDataURL, log, uwa, unity, CallbackManager) {
    var api;
    function findName(func, prefix, obj) {
        if (!prefix) {
            return findName(func, 'Unity.', api);
        }
        var keys = Object.keys(obj);
        for (var i = 0; i < keys.length; i++) {
            if (typeof(keys[i]) !== 'string') {
                continue;
            }
            var descr = Object.getOwnPropertyDescriptor(obj, keys[i]);
            if (descr.value === func) {
                return prefix + keys[i];
            }
            if (descr.value instanceof Object) {
                var res = findName(func, prefix + keys[i] + '.', obj[keys[i]]);
                if (res)
                    return res;
            }
            if (obj.__lookupGetter__(keys[i]) === func) {
                return prefix + keys[i];
            }
            if (obj.__lookupSetter__(keys[i]) === func) {
                return prefix + keys[i];
            }
        }
        return null;
    }
    function stringify(obj) {
        if (obj === undefined)
            return obj;
        if (obj === null)
            return obj;
        if (typeof(obj) == 'string')
            return obj;
        if (typeof(obj) == 'number')
            return obj;
        if (typeof(obj) == 'function')
            return String(obj);
        var dump = {};
        for (var i in obj) {
            if (obj.hasOwnProperty(i))
                dump[i] = stringify(obj[i]);
        }
        return dump;
    }
    function stringifyArgs(obj) {
        var args = [];
        for (var i = 0; i < obj.length; i++) {
            args.push(stringify(obj[i]));
        }
        var res = JSON.stringify(args);
        return res.substr(1, res.length - 2);
    }
    function createArgumentsSanitaizer(func, argsDesc) {
        return function () {
            var realArgs = arguments;

            var name = findName(arguments.callee);
            log(String(name) + '(' + stringifyArgs(arguments) + ')');

	    if (unity.context == null) {return;}
            var k = 0;
            function argumentSanitaizer(desc, arg) {
                if (!desc) {
		    throw new InternalError("argument description is null");
                }
                if (desc.dummy) {
                    k--;
                    return null;
                }
                if (desc.obj) {
                    if (!(desc.obj instanceof Object)) {
                        throw new InternalError("invalid argument description");
                    }
                    var res = [], i;
                    for (i in desc.obj) {
                        if (desc.obj.hasOwnProperty(i)) {
                            res.push(null);
                        }
                    }
                    for (i in desc.obj) {
                        if (desc.obj.hasOwnProperty(i)) {
                            res[desc.obj[i].place] = argumentSanitaizer(desc.obj[i], arg[i]);
                        }
                    }
                    return res;
                }
                if (desc.str) {
                    if (desc.allowNull && !arg) {
                        return null;
                    }
                    if (typeof(arg) !== 'string')
                        throw new TypeError("incorrect argument");
                    return arg;
                }
                if (desc.number) {
                    if (typeof(arg) !== 'number')
                        throw new TypeError("incorrect argument");
                    return arg;
                }
                if (!desc.type) {
                    throw new InternalError("argument description miss required parameter");
                }
                if ((arg instanceof desc.type) || (desc.type === Function && ((typeof arg) === 'function'))
                    || (arg === null && desc.allowNull)) {
                    if (desc.type === Function) {
                        if (!arg) {
                            return null;
                        }
                        return CallbackManager.makeCallback(uwa.ContextActionCallbackType,
							    function (context, user_data) {
                                                                arg();
                                                            });
                    }
                    return arg;
                } else {
                    throw new TypeError("incorrect argument");
                }
                throw new InternalError("unreacheable");
            }
            var args = [unity.context], i;
            for (i = 0; i < argsDesc.length; i++) {
                if (k >= realArgs.length && k > 0 && !argsDesc[i].dummy) {
                    throw new Error("not enough arguments");
                }

                var value = argumentSanitaizer(argsDesc[i], realArgs[k]);
                k++;
                if (value instanceof Array) {
                    args = args.concat(value);
                } else {
                    args.push(value);
                }
            }

            if (k < realArgs.length) {
                throw new Error("too much arguments");
            }

            return Function.apply.apply(func, [uwa, args]);
        };
    }

    api = {
	init: function(props) {
            init(props);
	},

	addAction: createArgumentsSanitaizer(uwa.context_add_application_action, [{ str: true },
                                                                                  { type: Function }, { dummy: true }]),
	clearAction: createArgumentsSanitaizer(uwa.context_remove_application_action,
					       [{ str: true }]),

	MusicPlayer: {
            init: createArgumentsSanitaizer(uwa.music_player_init, [{ str: true }]),

            onPlayPause: createArgumentsSanitaizer(uwa.music_player_on_play_pause_callback,
                                                   [{ type: Function, allowNull: true }, { dummy: true }]),

            onPrevious: createArgumentsSanitaizer(uwa.music_player_on_previous_callback,
                                                  [{ type: Function, allowNull: true }, { dummy: true }]),

            onNext: createArgumentsSanitaizer(uwa.music_player_on_next_callback,
                                              [{ type: Function, allowNull: true }, { dummy: true }]),

            setTrack: createArgumentsSanitaizer(uwa.music_player_set_track,
                                                [{ obj: { artist: { str: true, place: 0, allowNull: true },
                                                          album: { str: true, place: 1, allowNull: true },
                                                          title: { str: true, place: 2 },
                                                          artLocation: { str: true, place: 3, allowNull: true } } }]),
            PlaybackState: {PLAYING: 0, PAUSED:1}
	},

	Notification: {
            showNotification: createArgumentsSanitaizer(uwa.notification_show_notification,
                                                        [{ str: true }, { str: true }, { str: true, allowNull: true }])
	},

	Launcher: {
            setCount: createArgumentsSanitaizer(uwa.launcher_set_count,
                                                [{ number: true }]),
            clearCount: createArgumentsSanitaizer(uwa.launcher_clear_count,
                                                  []),
            setProgress: createArgumentsSanitaizer(uwa.launcher_set_progress,
                                                   [{ number: true }]),
            clearProgress: createArgumentsSanitaizer(uwa.launcher_clear_progress,
                                                     []),
            setUrgent: createArgumentsSanitaizer(uwa.launcher_set_urgent,
                                                 []),
            addAction: createArgumentsSanitaizer(uwa.launcher_add_action,
                                                 [{ str: true }, { type: Function }, { dummy: true }])
	},

	MessagingIndicator: {
            addAction: createArgumentsSanitaizer(uwa.indicator_add_action,
                                                 [{ str: true }, { type: Function }, { dummy: true }]),
            showIndicator: function(name, properties) {
                log('Unity.MessagingIndicator.showIndicator(' + stringifyArgs(arguments) + ')');

		if (unity.context == null) {return};

		if (name == null) {
		    throw new TypeError("name is null");
		}

		uwa.indicator_show_indicator(unity.context, String(name));
		for (i in properties) {
                    if (i == "time") {
			uwa.indicator_set_property(unity.context, String(name), i, UnityMiscUtils.toISODate(String(properties[i])));
                    }
                    else if (i == "icon") {
			uwa.indicator_set_property_icon(unity.context, String(name), i, String(properties[i]));
                    }
                    else if (i == "callback") {
			var callback = CallbackManager.makeCallback (uwa.IndicatorCallbackType,
								     function (context, user_data) {(properties[i])()});

			uwa.indicator_set_callback(unity.context, String(name), callback, null);
                    }
                    else {
			uwa.indicator_set_property(unity.context, String(name), i, String(properties[i]));
                    }
		}
            },
            clearIndicator: createArgumentsSanitaizer(uwa.indicator_clear_indicator, [{ str: true }]),
            clearIndicators: createArgumentsSanitaizer(uwa.indicator_clear_indicators, [])
	},

	toDataURL: function (uri, callback, sx, sy, sw, sh) {
            toDataURL(uri, callback, sx, sy, sw, sh);
	}
    };

    api.MusicPlayer.__defineGetter__("canGoNext",
                                     createArgumentsSanitaizer(uwa.music_player_get_can_go_next, []));
    api.MusicPlayer.__defineGetter__("canGoPrevious",
                                     createArgumentsSanitaizer(uwa.music_player_get_can_go_previous, []));
    api.MusicPlayer.__defineGetter__("canPlay",
                                     createArgumentsSanitaizer(uwa.music_player_get_can_play, []));
    api.MusicPlayer.__defineGetter__("canPause",
                                     createArgumentsSanitaizer(uwa.music_player_get_can_pause, []));
    api.MusicPlayer.__defineGetter__("playbackState",
                                     createArgumentsSanitaizer(uwa.music_player_get_playback_state, []));

    api.MusicPlayer.__defineSetter__("canGoNext",
                                     createArgumentsSanitaizer(uwa.music_player_set_can_go_next, [{ number: true }]));
    api.MusicPlayer.__defineSetter__("canGoPrevious",
                                     createArgumentsSanitaizer(uwa.music_player_set_can_go_previous, [{ number: true }]));
    api.MusicPlayer.__defineSetter__("canPlay",
                                     createArgumentsSanitaizer(uwa.music_player_set_can_play, [{ number: true }]));
    api.MusicPlayer.__defineSetter__("canPause",
                                     createArgumentsSanitaizer(uwa.music_player_set_can_pause, [{ number: true }]));
    api.MusicPlayer.__defineSetter__("playbackState",
                                     createArgumentsSanitaizer(uwa.music_player_set_playback_state, [{ number: true }]));

    return api;
}