// TODO just there for convenience, will probably reuse those from FF but w/ a better
//  module mecanism (dunno what is used by FF)

var UnityFaviconUtils = (function () {
	function findFaviconLink (document){
        var linkElements = document.getElementsByTagName("link");
        var i = 0;

        for (i = 0; i < linkElements.length; i++){
            var element = linkElements[i];

            if (element.hasAttribute("rel") &&
                (element.rel == "shortcut icon")) {
                var link = element.href;

                if (link[0] == "/") {
                    return document.location + link;
                } else {
                    return link;
                }
            }
        }

        return null;
    }

    UnityFaviconUtils = {
        getFaviconForDocument: function (document) {
            var favIcon = findFaviconLink (document);

            if (favIcon == null) {
                favIcon = "http://" + document.domain + "/favicon.ico";
            }

            return favIcon;
        }
    }

    return UnityFaviconUtils;

}) ();


var UnityWindowHelper = (function () {

    function UnityWindowHelper (aWindow) {
        this.window = aWindow;
    };

    UnityWindowHelper.prototype.FindToplevelContentWindow = function (aWindow) {
        var toplevelContentWindow = aWindow;

        while (toplevelContentWindow.parent != toplevelContentWindow){
            toplevelContentWindow = toplevelContentWindow.parent;
        }

        return toplevelContentWindow;
    };

    return new UnityWindowHelper ();

}) ();


var UnityPreviewUtils = (function () {
    function createCanvasElement (width, height) {
        var canvas = window.document.createElementNS("http://www.w3.org/1999/xhtml",
                                   "canvas");

        canvas.width = width;
        canvas.height = height;

        return canvas;
    }

    UnityPreviewUtils = {
        getPreviewForWindow: function (window, windowId) {
            while (window.parent != window) {
                window = window.parent;
            }

            chrome.tabs.captureVisibleTab (windowId, null, function (dataURL) {

            });

            return canvas.toDataURL();
        }
    }

    return UnityPreviewUtils;
})();


var UnityBindingFactory = function (pluginInstance, service, logger) {
    var _global = {
        context: null
    };
    var _instance = pluginInstance;

    function Unity () {
        this.service = service;
        this.logger = logger;
    };

    window.addEventListener("pagehide", function(event) {
        if (_global.context == null) {return;}

        _instance.context_destroy (_global.context);

        _global.context = null;
    }, false);

    function _initializeWithName (name, service, iconUrl, oninit, homepage) {
        var win = window;

        /// TODO: mmmh async ... race conditions ...
        var tabId = null;
        getTabId (function (response) { tabId = response.tabId; });

        var appRaise = function (context, userData) {
            raiseTabWithId (tabId);
        };
        var appClose = function (context, userData) {
            killTabWithId (tabId);
        };

        var previewRequested = function (context, user_data) {
                                    var previewData = null;
                                    var length = 0;
                                    var content = null;

                                     try {
                                        previewData = UnityPreviewUtils.getPreviewForWindow (document.defaultView);

                                        length = previewData.length+1;
                                        content = previewData+'\0'
                                     } catch (e) {
                                         console.log ("Unity Preview Error: " + e.toString());
                                     }

                                     return {
                                         length: length
                                         , content: content
//                                         , content: unescape (encodeURIComponent (previewData+'\0'));
                                     };
                                 };

        console.log ('document.domain ' + document.domain + ', ' + service + ', ' + name + ", homepage: " + homepage);

        _global.context = _instance.context_new_sync (service, name, document.domain, "none");

        _instance.context_add_icon (_global.context, UnityFaviconUtils.getFaviconForDocument (document), 16);
        _instance.context_on_raise_callback (_global.context, appRaise, null);
        _instance.context_on_close_callback (_global.context, appClose, null);
        _instance.context_set_preview_requested_callback (_global.context, previewRequested, null);

        if ((homepage != undefined) && (homepage != null)) {
            _instance.context_set_homepage (_global.context, homepage);
        }

        if (oninit != null) {
            try {
                console.log ('calling oninit');
                oninit();
            } catch (e) {
                console.log ("Unity Extension, error calling onInit callback: " + e.toString());
            }
        }

        _instance.context_set_view_is_active (_global.context, 1);
        console.log ('is active done');

//        _global.context.document = aWindow.document;
//        _global.context.parent = aWindow.parent;

        _instance.context_set_view_location (_global.context, document.location.toString());
    };

    function unityInit(props) {

        var name = props.name || "Undefined name";
        var onInit = props.onInit || function () { console.log ("Default onInit called for '" + name + "'") };
        var homepage = props.homepage;

        // TODO var currentBaseDomain = eTLDService.getBaseDomainFromHost(aWindow.document.domain); ?
        var domain = document.domain;

        function integrateActionCallback() {
            _initializeWithName (name, service, domain, onInit, homepage);
            _instance.permissions_allow_domain (domain);

            console.log ('integrateActionCallback: ' + _global.context);
        }

        function dontAskActionCallback() {
            _instance.permissions_dontask_domain (domain);
        }

        if (_instance.permissions_get_domain_dontask (domain)) {
            console.log ('permissions_get_domain_dontask: ' + domain);
            return;
        }

        // If we are adding the site for the first time and there is no homepage, store the point of integration.
        if (homepage == undefined) {
            homepage = UnityWindowHelper.FindToplevelContentWindow (window).document.location.toString();
        }

        /*            if (domain == "" || _instance.permissions_get_domain_allowed (domain)) {
         try {
         _initializeWithName (name, this.service, domain, onInit);
         }
         catch (e) {
         console.log("Unity Extension: Error calling realInit: " + e.toString() + e.line + e);
         }
         return;
         }*/

        // fallback to popup manager
        /*            PopupManager.requestIntegration(name, domain,
         integrateActionCallback,
         dontAskActionCallback);*/

        integrateActionCallback (name, this.service, domain, onInit, homepage);
    }
    function toDataURL(uri, callback, sx, sy, sw, sh) {

        // TODO resolve this
        // skip for now
        callback (true, null);
        return;

        if (uri.match(/^\s{0,}file:/i))
            return;

        if (uri.match(/^\s{0,}https:/i))
            return;

        function createCORSRequest(method, url) {
            var xhr = new XMLHttpRequest();
            if ("withCredentials" in xhr) {

                // Check if the XMLHttpRequest object has a "withCredentials" property.
                // "withCredentials" only exists on XMLHTTPRequest2 objects.
                xhr.open(method, url, true);

            }
            else {

                // Otherwise, CORS is not supported by the browser.
                xhr = null;

            }
            return xhr;
        }

        var xhr = createCORSRequest('GET', uri);
        if ( ! xhr) {
            throw new Error('CORS not supported');
        }

        var self = this;
        var canvas = document.createElementNS("http://www.w3.org/1999/xhtml",
                                              "canvas");
        function loaded() {

            var resp = xhr.responseText;

            var data = 'data:';
            data += xhr.getResponseHeader('Content-Type');
            data += ';base64,';

            var decodedResp = '';
            for(var i = 0, L = resp.length; i < L; ++i) {
                decodedResp += String.fromCharCode(resp.charCodeAt(i) & 255);
            }

            data += btoa(decodedResp);

            var img = new Image(data);
            img.onload = function() {
                ctx.drawImage(img, 0, 0);

                //                    var pixels = ctx.getImageData(16, 17, 1, 1).data;

                callback (true, canvas.toDataURL());
            };

            img.src = data;
        }

        xhr.onerror = function() {
            console.log('There was an error!');
        };

        xhr.overrideMimeType('text/plain;charset=x-user-defined');
        xhr.onload = loaded;
        xhr.send();

        /*            var img = new Image();

         img.onload = function() {
         var width = img.width, height = img.height;
         var hasExtraArgs = sx || sx === 0;
         if (hasExtraArgs) {
         width = sw;
         height = sh;
         }

         var dx  = 0, dy = 0;

         if (width > height)
         dy = width - height;
         else
         dx = height - width;

         canvas.width = width + dx;
         canvas.height = height + dy;

         var ctx = canvas.getContext('2d');
         if (hasExtraArgs)
         ctx.drawImage(img, sx, sy, sw, sh, dx / 2, dy / 2, width, height);
         else
         ctx.drawImage(img, dx / 2, dy / 2);

         callback (true, canvas.toDataURL());
         };

         img.src = uri;*/

    } // toDataUrl

    var CallbackManager = {
        makeCallback: function (type, callback) {
            return callback;
        }
    };
    function log(msg) {
        console.log(msg);
    }


    return function () {
        return makeAPI(unityInit, toDataURL, log, _instance, _global, CallbackManager);
    };
};


var Unity = (function () {
    var plugin = null;
    var service = null;
    var unity = null;

    function initializePluginConnection (logger){

        // should trigger a request for a GetValue in the plugin
        plugin = document.getElementById ("unityChromiumExtensionId");

        // should trigger toString()
        if ( ! plugin) {
            logger ('Could not bind to the scriptable NPAPI plugin');
        }
        else {

            // should trigger a toString()
            logger ("Got a plugin object: " + plugin);

            service = plugin.service_new ();

            logger ("Service object created: " + service);

            // global plugin initialization
            var factory = UnityBindingFactory (plugin, service, logger);
            unity = factory ();

    /*        aWindow.addEventListener("pagehide", function(event) {
                if (_global.context == null) {return;}

                if (ContextManager.removeContext (_global.context))
                    _instance.context_destroy(_global.context);

                _global.context = null;
            }, false);*/
        }
    }

    initializePluginConnection (function (msg) {console.log ("From page: " + msg);});

    return unity;

}) ();
